/* ----------------------------------------------------------------------
   SPARTA - Stochastic PArallel Rarefied-gas Time-accurate Analyzer
   http://sparta.sandia.gov
   Steve Plimpton, sjplimp@sandia.gov, Michael Gallis, magalli@sandia.gov
   Sandia National Laboratories

   Copyright (2014) Sandia Corporation.  Under the terms of Contract
   DE-AC04-94AL85000 with Sandia Corporation, the U.S. Government retains
   certain rights in this software.  This software is distributed under 
   the GNU General Public License.

   See the README file in the top-level SPARTA directory.
------------------------------------------------------------------------- */

#ifndef SPARTA_TIMER_H
#define SPARTA_TIMER_H

#include "pointers.h"

namespace SPARTA_NS {

enum{TIME_LOOP,TIME_MOVE,TIME_COLLIDE,TIME_SORT,TIME_COMM,TIME_MODIFY,TIME_OUTPUT,TIME_N};

class Timer : protected Pointers {
 public:
  double *array;

  Timer(class SPARTA *);
  ~Timer();
  void init();
  void stamp();
  void stamp(int);
  void barrier_start(int);
  void barrier_stop(int);
  double elapsed(int);

 private:
  double previous_time;
};

}

#endif
